#
# Register usage:
#   $6: scratch register
#   $7: used when loading next word of array
#   $8: pointer to next word of data
#   $9: remaining count
#  $10: max(array)

# Note: if the length is <= 0, the result is undefined (meaning is allowed to
#       be anything, because the user made a mistake)
	
.data
length:    .word 5   # the number of words in the array
array:     .space 20

.text
	.global main
	
main:
	# Create a pointer to array in $8, then use it as a 
	# base register to initialize the 5 array elements.

	addi	$8, $gp, array  # create pointer to array

	ori	$9, $0, 2    
	sw	$9, 0($8)       # array[0] = 2

	ori	$9, $0, 7
	sw	$9, 4($8)	# array[1] = 7

	addi	$9, $0, -2	# (addi required to sign extended result)
	sw	$9, 8($8)	# array[2] = -2

	ori	$9, $0, 10
	sw	$9, 12($8)	# array[3] = 10

	sw	$9, 16($8)	# array[4] = 10

	# initialize registers per reg usage comment at top
	addi	$8, $gp, array	# ptr to array[0]
	lw	$9, length($gp) # fetch length into $9
	lw	$10, 0($8)	# initial max is 0th array element

top:
	addi	$9, $9, -1	# decrement remaining length
	beq	$9, $0, done
	addi	$8, $8, 4	# increment pointer by 1 word = 4 bytes
	lw	$7, 0($8)	# get next array element
	slt	$6, $7, $10	# less than the current max?
	bne	$6, $0, top	# yes -- go to loop top
	or	$10, $7, $0	# copy new max into $10
	j	top

done:
	jr	$ra
	
	