#
# This code is written to be a translatino of part3.c into assembler.
# You should look at part3.c simultaneously with reading  this.
#
# Register usage:
#   $5: scratch
#   $6: char from head of string
#   $7: char from tail of string
#   $8: headPtr
#   $9: tailPtr
#  $10: result: 0 -> not a palindrome ; 1-> is a palindrome

.data
testString: .asciiz ",A+19, man, a plan, a canal, Pan-=@{ama!"

.text
	.global main
main:
	# initialize headPtr
	addi	$8, testString($gp)
	addi	$8, $8, -1

	# tailPtr for loop
	addi	$9, testString($gp)	# ptr to start of testString
tailLoop:
	lb	$6, 0($9)
	beq	$6, $0, forDone		# found '\0'?
	addi	$9, $9, 1		# increment by 1 byte = 1 char
	j	tailLoop
forDone:	

	# while(1)
mainLoop:

	addi	$8, $8, 1		# headPtr++
headWhileLoop:
	# fetch *headPtr
	lb	$6, 0($8)
	# note: we're lucky that no ascii alphabetic has the high bit
	#       on, because we have no lbu instruction in cebollita.
	#       (We'd probably have to use an and mask to zero the high order
	#       24 bits of $6 otherwise.)

	# force to lower case, for convenience
	ori	$6, $6, 0x20
	# isalpha(*headPtr)?
	slti	$5,$6, 0x61            	# byte has lower value than 'a'?
	bne	$5, $0, headNotAlpha	# yes
	slti	$5, $6, 0x7B	      	# byte has lower value than 'z'+1?
	bne	$5, $0, headWhileDone 	# yes - done with this loop
headNotAlpha:	
	slt	$5, $8, $9		# headPtr < tailPtr?
	beq	$5, $0, mainWhileDone	# yep - break from main loop
	addi	$8, $8, 1		# headPtr++
	j	headWhileLoop
headWhileDone:	


	addi	$9, $9, -1		# tailPtr--
tailWhileLoop:
	# fetch *tailPtr
	lb	$7, 0($9)
	ori	$7, $7, 0x20
	# isalpha(*tailPtr)?
	slti	$5,$7, 0x61            	# byte has lower value than 'a'?
	bne	$5, $0, tailNotAlpha	# yes
	slti	$5, $7, 0x7B	      	# byte has lower value than 'z'+1?
	bne	$5, $0, tailWhileDone 	# yes - done with this loop
tailNotAlpha:	
	slt	$5, $8, $9		# tailPtr < tailPtr?
	beq	$5, $0, mainWhileDone	# yep - break from main loop
	addi	$9, $9, -1		# tailPtr--
	j	tailWhileLoop
tailWhileDone:

	# tolower(*headPtr) != tolower(*tailPtr)
	bne	$6, $7, mainWhileDone

	j	mainLoop

mainWhileDone:

	# headPtr < tailPtr => not a palindrome
	# otherwise it is
	
	slt	$10, $8, $9
	xori	$10, $10, 1	# invert the lower order bit

	jr	$ra
	